diff --git a/freebsd/sys/kern/vfs_mount.c b/freebsd/sys/kern/vfs_mount.c
index 3610763f..4635857e 100644
--- a/freebsd/sys/kern/vfs_mount.c
+++ b/freebsd/sys/kern/vfs_mount.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -796,16 +798,22 @@ sys_mount(struct thread *td, struct mount_args *uap)
 	 */
 	flags &= ~MNT_ROOTFS;
 
+#ifndef __rtems__
 	fstype = malloc(MFSNAMELEN, M_TEMP, M_WAITOK);
 	error = copyinstr(uap->type, fstype, MFSNAMELEN, NULL);
 	if (error) {
 		free(fstype, M_TEMP);
 		return (error);
 	}
+#else /* __rtems__ */
+	fstype = uap->type;
+#endif /* __rtems__ */
 
 	AUDIT_ARG_TEXT(fstype);
 	vfsp = vfs_byname_kld(fstype, td, &error);
+#ifndef __rtems__
 	free(fstype, M_TEMP);
+#endif /* __rtems__ */
 	if (vfsp == NULL)
 		return (ENOENT);
 	if (vfsp->vfc_vfsops->vfs_cmount == NULL)
diff --git a/freebsd/sys/kern/vfs_subr.c b/freebsd/sys/kern/vfs_subr.c
index f84caac0..bc38e770 100644
--- a/freebsd/sys/kern/vfs_subr.c
+++ b/freebsd/sys/kern/vfs_subr.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -43,8 +45,8 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_ddb.h"
-#include "opt_watchdog.h"
+#include <rtems/bsd/local/opt_ddb.h>
+#include <rtems/bsd/local/opt_watchdog.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -57,14 +59,18 @@ __FBSDID("$FreeBSD$");
 #include <sys/dirent.h>
 #include <sys/event.h>
 #include <sys/eventhandler.h>
+#ifndef __rtems__
 #include <sys/extattr.h>
+#endif /* __rtems__ */
 #include <sys/file.h>
 #include <sys/fcntl.h>
 #include <sys/jail.h>
 #include <sys/kdb.h>
 #include <sys/kernel.h>
 #include <sys/kthread.h>
+#ifndef __rtems__
 #include <sys/lockf.h>
+#endif /* __rtems__ */
 #include <sys/malloc.h>
 #include <sys/mount.h>
 #include <sys/namei.h>
@@ -388,6 +394,7 @@ out:
 	return (error);
 }
 
+#ifndef __rtems__
 static int
 sysctl_ftry_reclaim_vnode(SYSCTL_HANDLER_ARGS)
 {
@@ -427,6 +434,7 @@ SYSCTL_PROC(_debug, OID_AUTO, ftry_reclaim_vnode,
     CTLTYPE_INT | CTLFLAG_MPSAFE | CTLFLAG_WR, NULL, 0,
     sysctl_ftry_reclaim_vnode, "I",
     "Try to reclaim a vnode by its file descriptor");
+#endif /* __rtems__ */
 
 /* Shift count for (uintptr_t)vp to initialize vp->v_hash. */
 static int vnsz2log;
@@ -492,7 +500,9 @@ vnode_init(void *mem, int size, int flags)
 	/*
 	 * Initialize rangelocks.
 	 */
+#ifndef __rtems__
 	rangelock_init(&vp->v_rl);
+#endif /* __rtems__ */
 	return (0);
 }
 
@@ -506,7 +516,9 @@ vnode_fini(void *mem, int size)
 	struct bufobj *bo;
 
 	vp = mem;
+#ifndef __rtems__
 	rangelock_destroy(&vp->v_rl);
+#endif /* __rtems__ */
 	lockdestroy(vp->v_vnlock);
 	mtx_destroy(&vp->v_interlock);
 	bo = &vp->v_bufobj;
@@ -551,10 +563,18 @@ vntblinit(void *dummy __unused)
 	 * size.  The memory required by desiredvnodes vnodes and vm objects
 	 * must not exceed 1/10th of the kernel's heap size.
 	 */
+#ifndef __rtems__
 	physvnodes = maxproc + pgtok(vm_cnt.v_page_count) / 64 +
 	    3 * min(98304 * 16, pgtok(vm_cnt.v_page_count)) / 64;
 	virtvnodes = vm_kmem_size / (10 * (sizeof(struct vm_object) +
 	    sizeof(struct vnode) + NC_SZ * ncsizefactor + NFS_NCLNODE_SZ));
+#else /* __rtems__ */
+	/*
+	 * Make a fixed number until someone decided on a better solution for RTEMS
+	 */
+	physvnodes = 128;
+	virtvnodes = 128;
+#endif /* __rtems__ */
 	desiredvnodes = min(physvnodes, virtvnodes);
 	if (desiredvnodes > MAXVNODES_MAX) {
 		if (bootverbose)
@@ -1005,7 +1025,11 @@ vlrureclaim(struct mount *mp, bool reclaim_nc_src, int trigger)
 		    (!reclaim_nc_src && !LIST_EMPTY(&vp->v_cache_src)) ||
 		    ((vp->v_iflag & VI_FREE) != 0) ||
 		    (vp->v_iflag & VI_DOOMED) != 0 || (vp->v_object != NULL &&
+#ifndef __rtems__
 		    vp->v_object->resident_page_count > trigger)) {
+#else /* __rtems__ */
+		    false)) {
+#endif /* __rtems__ */
 			VI_UNLOCK(vp);
 			goto next_iter;
 		}
@@ -1032,7 +1056,11 @@ vlrureclaim(struct mount *mp, bool reclaim_nc_src, int trigger)
 		    (!reclaim_nc_src && !LIST_EMPTY(&vp->v_cache_src)) ||
 		    (vp->v_iflag & VI_FREE) != 0 ||
 		    (vp->v_object != NULL &&
+#ifndef __rtems__
 		    vp->v_object->resident_page_count > trigger)) {
+#else /* __rtems__ */
+		    false)) {
+#endif /* __rtems__ */
 			VOP_UNLOCK(vp, LK_INTERLOCK);
 			vdrop(vp);
 			goto next_iter_mntunlocked;
@@ -1045,15 +1073,21 @@ vlrureclaim(struct mount *mp, bool reclaim_nc_src, int trigger)
 		vdropl(vp);
 		done++;
 next_iter_mntunlocked:
+#ifndef __rtems__
 		if (!should_yield())
 			goto relock_mnt;
+#endif /* __rtems__ */
 		goto yield;
 next_iter:
+#ifndef __rtems__
 		if (!should_yield())
 			continue;
+#endif /* __rtems__ */
 		MNT_IUNLOCK(mp);
 yield:
+#ifndef __rtems__
 		kern_yield(PRI_USER);
+#endif /* __rtems__ */
 relock_mnt:
 		MNT_ILOCK(mp);
 	}
@@ -1247,12 +1281,16 @@ vnlru_proc(void)
 	int done, force, trigger, usevnodes, vsp;
 	bool reclaim_nc_src;
 
+#ifndef __rtems__
 	EVENTHANDLER_REGISTER(shutdown_pre_sync, kproc_shutdown, vnlruproc,
 	    SHUTDOWN_PRI_FIRST);
+#endif /* __rtems__ */
 
 	force = 0;
 	for (;;) {
+#ifndef __rtems__
 		kproc_suspend_check(vnlruproc);
+#endif /* __rtems__ */
 		mtx_lock(&vnode_free_list_mtx);
 		/*
 		 * If numvnodes is too large (due to desiredvnodes being
@@ -1304,7 +1342,11 @@ vnlru_proc(void)
 		 * misconfigured cases, and this is necessary.  Normally
 		 * it is about 8 to 100 (pages), which is quite large.
 		 */
+#ifndef __rtems__
 		trigger = vm_cnt.v_page_count * 2 / usevnodes;
+#else /* __rtems__ */
+		trigger = 32000 / usevnodes;
+#endif /* __rtems__ */
 		if (force < 2)
 			trigger = vsmalltrigger;
 		reclaim_nc_src = force >= 3;
@@ -1789,6 +1831,7 @@ bufobj_invalbuf(struct bufobj *bo, int flags, int slpflag, int slptimeo)
 	 */
 	do {
 		bufobj_wwait(bo, 0, 0);
+#ifndef __rtems__
 		if ((flags & V_VMIO) == 0) {
 			BO_UNLOCK(bo);
 			if (bo->bo_object != NULL) {
@@ -1798,12 +1841,14 @@ bufobj_invalbuf(struct bufobj *bo, int flags, int slpflag, int slptimeo)
 			}
 			BO_LOCK(bo);
 		}
+#endif /* __rtems__ */
 	} while (bo->bo_numoutput > 0);
 	BO_UNLOCK(bo);
 
 	/*
 	 * Destroy the copy in the VM cache, too.
 	 */
+#ifndef __rtems__
 	if (bo->bo_object != NULL &&
 	    (flags & (V_ALT | V_NORMAL | V_CLEANONLY | V_VMIO)) == 0) {
 		VM_OBJECT_WLOCK(bo->bo_object);
@@ -1811,6 +1856,7 @@ bufobj_invalbuf(struct bufobj *bo, int flags, int slpflag, int slptimeo)
 		    OBJPR_CLEANONLY : 0);
 		VM_OBJECT_WUNLOCK(bo->bo_object);
 	}
+#endif /* __rtems__ */
 
 #ifdef INVARIANTS
 	BO_LOCK(bo);
@@ -1836,8 +1882,10 @@ vinvalbuf(struct vnode *vp, int flags, int slpflag, int slptimeo)
 
 	CTR3(KTR_VFS, "%s: vp %p with flags %d", __func__, vp, flags);
 	ASSERT_VOP_LOCKED(vp, "vinvalbuf");
+#ifndef __rtems__
 	if (vp->v_object != NULL && vp->v_object->handle != vp)
 		return (0);
+#endif /* __rtems__ */
 	return (bufobj_invalbuf(&vp->v_bufobj, flags, slpflag, slptimeo));
 }
 
@@ -2005,7 +2053,9 @@ restartsync:
 
 	bufobj_wwait(bo, 0, 0);
 	BO_UNLOCK(bo);
+#ifndef __rtems__
 	vnode_pager_setsize(vp, length);
+#endif /* __rtems__ */
 
 	return (0);
 }
@@ -2354,15 +2404,19 @@ sched_sync(void)
 	starttime = time_uptime;
 	td->td_pflags |= TDP_NORUNNINGBUF;
 
+#ifndef __rtems__
 	EVENTHANDLER_REGISTER(shutdown_pre_sync, syncer_shutdown, td->td_proc,
 	    SHUTDOWN_PRI_LAST);
+#endif /* __rtems__ */
 
 	mtx_lock(&sync_mtx);
 	for (;;) {
 		if (syncer_state == SYNCER_FINAL_DELAY &&
 		    syncer_final_iter == 0) {
 			mtx_unlock(&sync_mtx);
+#ifndef __rtems__
 			kproc_suspend_check(td->td_proc);
+#endif /* __rtems__ */
 			mtx_lock(&sync_mtx);
 		}
 		net_worklist_len = syncer_worklist_len - sync_vnode_count;
@@ -2427,7 +2481,9 @@ sched_sync(void)
 				 * drivers need to sleep while patting
 				 */
 				mtx_unlock(&sync_mtx);
+#ifndef __rtems__
 				wdog_kern_pat(WD_LASTVAL);
+#endif /* __rtems__ */
 				mtx_lock(&sync_mtx);
 			}
 
@@ -2460,12 +2516,14 @@ sched_sync(void)
 		 * matter as we are just trying to generally pace the
 		 * filesystem activity.
 		 */
+#ifndef __rtems__
 		if (syncer_state != SYNCER_RUNNING ||
 		    time_uptime == starttime) {
 			thread_lock(td);
 			sched_prio(td, PPAUSE);
 			thread_unlock(td);
 		}
+#endif /* __rtems__ */
 		if (syncer_state != SYNCER_RUNNING)
 			cv_timedwait(&sync_wakeup, &sync_mtx,
 			    hz / SYNCER_SHUTDOWN_SPEEDUP);
@@ -3127,8 +3185,10 @@ _vdrop(struct vnode *vp, bool locked)
 	VNASSERT(TAILQ_EMPTY(&vp->v_cache_dst), vp, ("vp has namecache dst"));
 	VNASSERT(LIST_EMPTY(&vp->v_cache_src), vp, ("vp has namecache src"));
 	VNASSERT(vp->v_cache_dd == NULL, vp, ("vp has namecache for .."));
+#ifndef __rtems__
 	VNASSERT(TAILQ_EMPTY(&vp->v_rl.rl_waiters), vp,
 	    ("Dangling rangelock waiters"));
+#endif /* __rtems__ */
 	VI_UNLOCK(vp);
 #ifdef MAC
 	mac_vnode_destroy(vp);
@@ -3181,12 +3241,14 @@ vinactive(struct vnode *vp, struct thread *td)
 	 * point that VOP_INACTIVE() is called, there could still be
 	 * pending I/O and dirty pages in the object.
 	 */
+#ifndef __rtems__
 	if ((obj = vp->v_object) != NULL && (vp->v_vflag & VV_NOSYNC) == 0 &&
 	    (obj->flags & OBJ_MIGHTBEDIRTY) != 0) {
 		VM_OBJECT_WLOCK(obj);
 		vm_object_page_clean(obj, 0, 0, 0);
 		VM_OBJECT_WUNLOCK(obj);
 	}
+#endif /* __rtems__ */
 	VOP_INACTIVE(vp, td);
 	VI_LOCK(vp);
 	VNASSERT(vp->v_iflag & VI_DOINGINACT, vp,
@@ -3266,9 +3328,11 @@ loop:
 		 */
 		if (flags & WRITECLOSE) {
 			if (vp->v_object != NULL) {
+#ifndef __rtems__
 				VM_OBJECT_WLOCK(vp->v_object);
 				vm_object_page_clean(vp->v_object, 0, 0, 0);
 				VM_OBJECT_WUNLOCK(vp->v_object);
+#endif /* __rtems__ */
 			}
 			error = VOP_FSYNC(vp, MNT_WAIT, td);
 			if (error != 0) {
@@ -3490,7 +3554,11 @@ vgonel(struct vnode *vp)
 		VI_UNLOCK(vp);
 	}
 	if (vp->v_type == VSOCK)
+#ifndef __rtems__
 		vfs_unp_reclaim(vp);
+#else /* __rtems__ */
+		panic("vgonel with sock");
+#endif /* __rtems__ */
 
 	/*
 	 * Clean out any buffers associated with the vnode.
@@ -3671,6 +3739,7 @@ vn_printf(struct vnode *vp, const char *fmt, ...)
 	printf("    flags (%s)\n", buf + 1);
 	if (mtx_owned(VI_MTX(vp)))
 		printf(" VI_LOCKed");
+#ifndef __rtems__
 	if (vp->v_object != NULL)
 		printf("    v_object %p ref %d pages %d "
 		    "cleanbuf %d dirtybuf %d\n",
@@ -3678,6 +3747,7 @@ vn_printf(struct vnode *vp, const char *fmt, ...)
 		    vp->v_object->resident_page_count,
 		    vp->v_bufobj.bo_clean.bv_cnt,
 		    vp->v_bufobj.bo_dirty.bv_cnt);
+#endif /* __rtems__ */
 	printf("    ");
 	lockmgr_printinfo(vp->v_vnlock);
 	if (vp->v_data != NULL)
@@ -4216,6 +4286,7 @@ vfs_unmountall(void)
 void
 vfs_msync(struct mount *mp, int flags)
 {
+#ifndef __rtems__
 	struct vnode *vp, *mvp;
 	struct vm_object *obj;
 
@@ -4248,6 +4319,7 @@ vfs_msync(struct mount *mp, int flags)
 		} else
 			VI_UNLOCK(vp);
 	}
+#endif /* __rtems__ */
 }
 
 static void
@@ -4452,10 +4524,14 @@ sync_fsync(struct vop_fsync_args *ap)
 		vfs_unbusy(mp);
 		return (0);
 	}
+#ifndef __rtems__
 	save = curthread_pflags_set(TDP_SYNCIO);
+#endif /* __rtems__ */
 	vfs_msync(mp, MNT_NOWAIT);
 	error = VFS_SYNC(mp, MNT_LAZY);
+#ifndef __rtems__
 	curthread_pflags_restore(save);
+#endif /* __rtems__ */
 	vn_finished_write(mp);
 	vfs_unbusy(mp);
 	return (error);
@@ -4656,6 +4732,7 @@ int
 extattr_check_cred(struct vnode *vp, int attrnamespace, struct ucred *cred,
     struct thread *td, accmode_t accmode)
 {
+#ifndef __rtems__
 
 	/*
 	 * Kernel-invoked always succeeds.
@@ -4676,6 +4753,9 @@ extattr_check_cred(struct vnode *vp, int attrnamespace, struct ucred *cred,
 	default:
 		return (EPERM);
 	}
+#else /* __rtems__ */
+	return (0);
+#endif /* __rtems__ */
 }
 
 #ifdef DEBUG_VFS_LOCKS
@@ -5438,8 +5518,10 @@ __mnt_vnode_next_all(struct vnode **mvp, struct mount *mp)
 {
 	struct vnode *vp;
 
+#ifndef __rtems__
 	if (should_yield())
 		kern_yield(PRI_USER);
+#endif /* __rtems__ */
 	MNT_ILOCK(mp);
 	KASSERT((*mvp)->v_mount == mp, ("marker vnode mount list mismatch"));
 	for (vp = TAILQ_NEXT(*mvp, v_nmntvnodes); vp != NULL;
@@ -5664,8 +5746,10 @@ struct vnode *
 __mnt_vnode_next_active(struct vnode **mvp, struct mount *mp)
 {
 
+#ifndef __rtems__
 	if (should_yield())
 		kern_yield(PRI_USER);
+#endif /* __rtems__ */
 	mtx_lock(&mp->mnt_listmtx);
 	return (mnt_vnode_next_active(mvp, mp));
 }
diff --git a/freebsd/sys/kern/vfs_syscalls.c b/freebsd/sys/kern/vfs_syscalls.c
index 06aaa935..0b7e054a 100644
--- a/freebsd/sys/kern/vfs_syscalls.c
+++ b/freebsd/sys/kern/vfs_syscalls.c
@@ -1,3 +1,5 @@
+#include <machine/rtems-bsd-kernel-space.h>
+
 /*-
  * SPDX-License-Identifier: BSD-3-Clause
  *
@@ -39,8 +41,8 @@
 #include <sys/cdefs.h>
 __FBSDID("$FreeBSD$");
 
-#include "opt_capsicum.h"
-#include "opt_ktrace.h"
+#include <rtems/bsd/local/opt_capsicum.h>
+#include <rtems/bsd/local/opt_ktrace.h>
 
 #include <sys/param.h>
 #include <sys/systm.h>
@@ -65,7 +67,7 @@ __FBSDID("$FreeBSD$");
 #include <sys/sdt.h>
 #include <sys/stat.h>
 #include <sys/sx.h>
-#include <sys/unistd.h>
+#include <rtems/bsd/sys/unistd.h>
 #include <sys/vnode.h>
 #include <sys/priv.h>
 #include <sys/proc.h>
@@ -87,7 +89,9 @@ __FBSDID("$FreeBSD$");
 #include <vm/vm_page.h>
 #include <vm/uma.h>
 
+#ifndef __rtems__
 #include <ufs/ufs/quota.h>
+#endif /* __rtems__ */
 
 MALLOC_DEFINE(M_FADVISE, "fadvise", "posix_fadvise(2) information");
 
@@ -151,6 +155,7 @@ sys_sync(struct thread *td, struct sync_args *uap)
 	return (0);
 }
 
+#ifndef __rtems__
 /*
  * Change filesystem quotas.
  */
@@ -203,6 +208,7 @@ sys_quotactl(struct thread *td, struct quotactl_args *uap)
 		vfs_unbusy(mp);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Used by statfs conversion routines to scale the block size up if
@@ -904,6 +910,7 @@ kern_chdir(struct thread *td, char *path, enum uio_seg pathseg)
 	return (0);
 }
 
+#ifndef __rtems__
 /*
  * Change notion of root (``/'') directory.
  */
@@ -945,6 +952,7 @@ error:
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Common routine for chroot and chdir.  Callers must provide a locked vnode
@@ -999,8 +1007,10 @@ flags_to_rights(int flags, cap_rights_t *rightsp)
 	if (flags & (O_SYNC | O_FSYNC))
 		cap_rights_set(rightsp, CAP_FSYNC);
 
+#ifndef __rtems__
 	if (flags & (O_EXLOCK | O_SHLOCK))
 		cap_rights_set(rightsp, CAP_FLOCK);
+#endif /* __rtems__ */
 }
 
 /*
@@ -1061,9 +1071,13 @@ kern_openat(struct thread *td, int fd, char *path, enum uio_seg pathseg,
 	 * Only one of the O_EXEC, O_RDONLY, O_WRONLY and O_RDWR flags
 	 * may be specified.
 	 */
+#ifndef __rtems__
 	if (flags & O_EXEC) {
 		if (flags & O_ACCMODE)
 			return (EINVAL);
+#else /* __rtems__ */
+	if (false) {
+#endif /* __rtems__ */
 	} else if ((flags & O_ACCMODE) == O_ACCMODE) {
 		return (EINVAL);
 	} else {
@@ -1083,10 +1097,16 @@ kern_openat(struct thread *td, int fd, char *path, enum uio_seg pathseg,
 	 */
 	/* Set the flags early so the finit in devfs can pick them up. */
 	fp->f_flag = flags & FMASK;
+#ifndef __rtems__
 	cmode = ((mode & ~fdp->fd_cmask) & ALLPERMS) & ~S_ISTXT;
+#else /* __rtems__ */
+	cmode = (mode & ~fdp->fd_cmask) & ALLPERMS;
+#endif /* __rtems__ */
 	NDINIT_ATRIGHTS(&nd, LOOKUP, FOLLOW | AUDITVNODE1, pathseg, path, fd,
 	    &rights, td);
+#ifndef __rtems__
 	td->td_dupfd = -1;		/* XXX check for fdopen */
+#endif /* __rtems__ */
 	error = vn_open(&nd, &flags, cmode, fp);
 	if (error != 0) {
 		/*
@@ -1106,16 +1126,23 @@ kern_openat(struct thread *td, int fd, char *path, enum uio_seg pathseg,
 		 */
 		if ((nd.ni_lcf & NI_LCF_STRICTRELATIVE) == 0 &&
 		    (error == ENODEV || error == ENXIO) &&
+#ifndef __rtems__
 		    td->td_dupfd >= 0) {
 			error = dupfdopen(td, fdp, td->td_dupfd, flags, error,
 			    &indx);
 			if (error == 0)
 				goto success;
+#else /* __rtems__ */
+		    true) {
+			panic("fdopen() dup");
+#endif /* __rtems__ */
 		}
 
 		goto bad;
 	}
+#ifndef __rtems__
 	td->td_dupfd = 0;
+#endif /* __rtems__ */
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	vp = nd.ni_vp;
 
@@ -1255,12 +1282,16 @@ kern_mknodat(struct thread *td, int fd, char *path, enum uio_seg pathseg,
 		if (error == 0 && dev == VNOVAL)
 			error = EINVAL;
 		break;
+#ifndef __rtems__
 	case S_IFWHT:
 		error = priv_check(td, PRIV_VFS_MKNOD_WHT);
 		break;
+#endif /* __rtems__ */
 	case S_IFIFO:
+#ifndef __rtems__
 		if (dev == 0)
 			return (kern_mkfifoat(td, fd, path, pathseg, mode));
+#endif /* __rtems__ */
 		/* FALLTHROUGH */
 	default:
 		error = EINVAL;
@@ -1298,9 +1329,11 @@ restart:
 		case S_IFBLK:
 			vattr.va_type = VBLK;
 			break;
+#ifndef __rtems__
 		case S_IFWHT:
 			whiteout = 1;
 			break;
+#endif /* __rtems__ */
 		default:
 			panic("kern_mknod: invalid mode");
 		}
@@ -1333,6 +1366,7 @@ restart:
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Create a named pipe.
  */
@@ -1418,6 +1452,7 @@ out:
 	NDFREE(&nd, NDF_ONLY_PNBUF);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Make a hard file link.
@@ -1459,15 +1494,19 @@ sys_linkat(struct thread *td, struct linkat_args *uap)
 }
 
 int hardlink_check_uid = 0;
+#ifndef __rtems__
 SYSCTL_INT(_security_bsd, OID_AUTO, hardlink_check_uid, CTLFLAG_RW,
     &hardlink_check_uid, 0,
     "Unprivileged processes cannot create hard links to files owned by other "
     "users");
+#endif /* __rtems__ */
 static int hardlink_check_gid = 0;
+#ifndef __rtems__
 SYSCTL_INT(_security_bsd, OID_AUTO, hardlink_check_gid, CTLFLAG_RW,
     &hardlink_check_gid, 0,
     "Unprivileged processes cannot create hard links to files owned by other "
     "groups");
+#endif /* __rtems__ */
 
 static int
 can_hardlink(struct vnode *vp, struct ucred *cred)
@@ -1689,6 +1728,7 @@ out:
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Delete a whiteout from the filesystem.
  */
@@ -1735,6 +1775,7 @@ restart:
 	vn_finished_write(mp);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Delete a name from the filesystem.
@@ -1952,6 +1993,7 @@ sys_access(struct thread *td, struct access_args *uap)
 	    0, uap->amode));
 }
 
+#ifndef __rtems__
 #ifndef _SYS_SYSPROTO_H_
 struct faccessat_args {
 	int	dirfd;
@@ -2014,7 +2056,9 @@ out:
 	}
 	return (error);
 }
+#endif /* __rtems__ */
 
+#ifndef __rtems__
 /*
  * Check access permissions using "effective" credentials.
  */
@@ -2031,7 +2075,9 @@ sys_eaccess(struct thread *td, struct eaccess_args *uap)
 	return (kern_accessat(td, AT_FDCWD, uap->path, UIO_USERSPACE,
 	    AT_EACCESS, uap->amode));
 }
+#endif /* __rtems__ */
 
+#ifndef __rtems__
 #if defined(COMPAT_43)
 /*
  * Get file status; this version follows links.
@@ -2256,6 +2302,7 @@ freebsd11_fstatat(struct thread *td, struct freebsd11_fstatat_args* uap)
 	return (error);
 }
 #endif	/* COMPAT_FREEBSD11 */
+#endif /* __rtems__ */
 
 /*
  * Get file status
@@ -2398,6 +2445,7 @@ freebsd11_nlstat(struct thread *td, struct freebsd11_nlstat_args *uap)
 }
 #endif /* COMPAT_FREEBSD11 */
 
+#ifndef __rtems__
 /*
  * Get configurable pathname variables.
  */
@@ -2456,6 +2504,7 @@ kern_pathconf(struct thread *td, char *path, enum uio_seg pathseg, int name,
 	vput(nd.ni_vp);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Return target name of a symbolic link.
@@ -2607,6 +2656,7 @@ sys_chflags(struct thread *td, struct chflags_args *uap)
 	    uap->flags, 0));
 }
 
+#ifndef __rtems__
 #ifndef _SYS_SYSPROTO_H_
 struct chflagsat_args {
 	int	fd;
@@ -2695,6 +2745,7 @@ sys_fchflags(struct thread *td, struct fchflags_args *uap)
 	fdrop(fp, td);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Common implementation code for chmod(), lchmod() and fchmod().
@@ -2954,6 +3005,7 @@ sys_fchown(struct thread *td, struct fchown_args *uap)
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Common implementation code for utimes(), lutimes(), and futimes().
  */
@@ -3272,6 +3324,7 @@ kern_utimensat(struct thread *td, int fd, char *path, enum uio_seg pathseg,
 	vrele(nd.ni_vp);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Truncate a file given its path name.
@@ -3396,11 +3449,13 @@ kern_fsync(struct thread *td, int fd, bool fullsync)
 	}
 	vn_lock(vp, lock_flags | LK_RETRY);
 	AUDIT_ARG_VNODE1(vp);
+#ifndef __rtems__
 	if (vp->v_object != NULL) {
 		VM_OBJECT_WLOCK(vp->v_object);
 		vm_object_page_clean(vp->v_object, 0, 0, 0);
 		VM_OBJECT_WUNLOCK(vp->v_object);
 	}
+#endif /* __rtems__ */
 	error = fullsync ? VOP_FSYNC(vp, MNT_WAIT, td) : VOP_FDATASYNC(vp, td);
 	VOP_UNLOCK(vp, 0);
 	vn_finished_write(mp);
@@ -3481,6 +3536,7 @@ again:
 	    AUDITVNODE1, pathseg, old, oldfd,
 	    &cap_renameat_source_rights, td);
 #else
+
 	NDINIT_ATRIGHTS(&fromnd, DELETE, WANTPARENT | SAVESTART | AUDITVNODE1,
 	    pathseg, old, oldfd,
 	    &cap_renameat_source_rights, td);
@@ -4035,6 +4091,7 @@ fail:
 	return (error);
 }
 
+#ifndef __rtems__
 /*
  * Set the mode mask for creation of filesystem nodes.
  */
@@ -4102,6 +4159,7 @@ out:
 	vput(vp);
 	return (error);
 }
+#endif /* __rtems__ */
 
 /*
  * Convert a user file descriptor to a kernel file entry and check that, if it
@@ -4139,6 +4197,7 @@ getvnode(struct thread *td, int fd, cap_rights_t *rightsp, struct file **fpp)
 }
 
 
+#ifndef __rtems__
 /*
  * Get an (NFS) file handle.
  */
@@ -4515,6 +4574,7 @@ out:
 	vfs_unbusy(mp);
 	return (error);
 }
+#endif /* __rtems__ */
 
 int
 kern_posix_fallocate(struct thread *td, int fd, off_t offset, off_t len)
@@ -4600,6 +4660,7 @@ kern_posix_fallocate(struct thread *td, int fd, off_t offset, off_t len)
 	return (error);
 }
 
+#ifndef __rtems__
 int
 sys_posix_fallocate(struct thread *td, struct posix_fallocate_args *uap)
 {
@@ -4746,3 +4807,4 @@ sys_posix_fadvise(struct thread *td, struct posix_fadvise_args *uap)
 	    uap->advice);
 	return (kern_posix_error(td, error));
 }
+#endif /* __rtems__ */
